Code

Demote git-p4import to contrib status.
[git.git] / git-stash.sh
1 #!/bin/sh
2 # Copyright (c) 2007, Nanako Shiraishi
4 USAGE='[ | list | show | apply | clear]'
6 SUBDIRECTORY_OK=Yes
7 . git-sh-setup
8 require_work_tree
10 TMP="$GIT_DIR/.git-stash.$$"
11 trap 'rm -f "$TMP-*"' 0
13 ref_stash=refs/stash
15 no_changes () {
16         git diff-index --quiet --cached HEAD &&
17         git diff-files --quiet
18 }
20 clear_stash () {
21         logfile="$GIT_DIR/logs/$ref_stash" &&
22         mkdir -p "$(dirname "$logfile")" &&
23         : >"$logfile"
24 }
26 save_stash () {
27         stash_msg="$1"
29         if no_changes
30         then
31                 echo >&2 'No local changes to save'
32                 exit 0
33         fi
34         test -f "$GIT_DIR/logs/$ref_stash" ||
35                 clear_stash || die "Cannot initialize stash"
37         # state of the base commit
38         if b_commit=$(git rev-parse --verify HEAD)
39         then
40                 head=$(git log --abbrev-commit --pretty=oneline -n 1 HEAD)
41         else
42                 die "You do not have the initial commit yet"
43         fi
45         if branch=$(git symbolic-ref -q HEAD)
46         then
47                 branch=${branch#refs/heads/}
48         else
49                 branch='(no branch)'
50         fi
51         msg=$(printf '%s: %s' "$branch" "$head")
53         # state of the index
54         i_tree=$(git write-tree) &&
55         i_commit=$(printf 'index on %s' "$msg" |
56                 git commit-tree $i_tree -p $b_commit) ||
57                 die "Cannot save the current index state"
59         # state of the working tree
60         w_tree=$( (
61                 rm -f "$TMP-index" &&
62                 cp -p ${GIT_INDEX_FILE-"$GIT_DIR/index"} "$TMP-index" &&
63                 GIT_INDEX_FILE="$TMP-index" &&
64                 export GIT_INDEX_FILE &&
65                 git read-tree -m $i_tree &&
66                 git add -u &&
67                 git write-tree &&
68                 rm -f "$TMP-index"
69         ) ) ||
70                 die "Cannot save the current worktree state"
72         # create the stash
73         if test -z "$stash_msg"
74         then
75                 stash_msg=$(printf 'WIP on %s' "$msg")
76         else
77                 stash_msg=$(printf 'On %s: %s' "$branch" "$stash_msg")
78         fi
79         w_commit=$(printf '%s\n' "$stash_msg" |
80                 git commit-tree $w_tree -p $b_commit -p $i_commit) ||
81                 die "Cannot record working tree state"
83         git update-ref -m "$stash_msg" $ref_stash $w_commit ||
84                 die "Cannot save the current status"
85         printf >&2 'Saved "%s"\n' "$stash_msg"
86 }
88 have_stash () {
89         git rev-parse --verify $ref_stash >/dev/null 2>&1
90 }
92 list_stash () {
93         have_stash || return 0
94         git log --pretty=oneline -g "$@" $ref_stash |
95         sed -n -e 's/^[.0-9a-f]* refs\///p'
96 }
98 show_stash () {
99         flags=$(git rev-parse --no-revs --flags "$@")
100         if test -z "$flags"
101         then
102                 flags=--stat
103         fi
104         s=$(git rev-parse --revs-only --no-flags --default $ref_stash "$@")
106         w_commit=$(git rev-parse --verify "$s") &&
107         b_commit=$(git rev-parse --verify "$s^") &&
108         git diff $flags $b_commit $w_commit
111 apply_stash () {
112         git diff-files --quiet ||
113                 die 'Cannot restore on top of a dirty state'
115         unstash_index=
116         case "$1" in
117         --index)
118                 unstash_index=t
119                 shift
120         esac
122         # current index state
123         c_tree=$(git write-tree) ||
124                 die 'Cannot apply a stash in the middle of a merge'
126         s=$(git rev-parse --revs-only --no-flags --default $ref_stash "$@") &&
127         w_tree=$(git rev-parse --verify "$s:") &&
128         b_tree=$(git rev-parse --verify "$s^:") ||
129                 die "$*: no valid stashed state found"
131         test -z "$unstash_index" || {
132                 git diff --binary $s^2^..$s^2 | git apply --cached
133                 test $? -ne 0 &&
134                         die 'Conflicts in index. Try without --index.'
135                 unstashed_index_tree=$(git-write-tree) ||
136                         die 'Could not save index tree'
137                 git reset
138         }
140         eval "
141                 GITHEAD_$w_tree='Stashed changes' &&
142                 GITHEAD_$c_tree='Updated upstream' &&
143                 GITHEAD_$b_tree='Version stash was based on' &&
144                 export GITHEAD_$w_tree GITHEAD_$c_tree GITHEAD_$b_tree
145         "
147         if git-merge-recursive $b_tree -- $c_tree $w_tree
148         then
149                 # No conflict
150                 a="$TMP-added" &&
151                 git diff --cached --name-only --diff-filter=A $c_tree >"$a" &&
152                 git read-tree --reset $c_tree &&
153                 git update-index --add --stdin <"$a" ||
154                         die "Cannot unstage modified files"
155                 git-status
156                 rm -f "$a"
157                 test -z "$unstash_index" || git read-tree $unstashed_index_tree
158         else
159                 # Merge conflict; keep the exit status from merge-recursive
160                 status=$?
161                 test -z "$unstash_index" || echo 'Index was not unstashed.' >&2
162                 exit $status
163         fi
166 # Main command set
167 case "$1" in
168 list)
169         shift
170         if test $# = 0
171         then
172                 set x -n 10
173                 shift
174         fi
175         list_stash "$@"
176         ;;
177 show)
178         shift
179         show_stash "$@"
180         ;;
181 apply)
182         shift
183         apply_stash "$@"
184         ;;
185 clear)
186         clear_stash
187         ;;
188 help | usage)
189         usage
190         ;;
191 *)
192         if test $# -gt 0 && test "$1" = save
193         then
194                 shift
195         fi
196         save_stash "$*" && git-reset --hard
197         ;;
198 esac